import compose from 'koa-compose'
import context from './context'

export default class Application {
  constructor() {
    this.middleware = []
    this.context = Object.create(context)
  }

  unshift(fn) {
    this.middleware.unshift(fn)
    return this
  }

  push(fn) {
    this.middleware.push(fn)
    return this
  }

  use(fn) {
    this.push(fn)
    return this
  }

  start() {
    setTimeout(this.exec.bind(this), 0)
  }

  exec() {
    let fn = compose(this.middleware)
    let ctx = this.context
    ctx.app = this
    fn(ctx)
  }
}
